
        subroutine optgeom()
        use projection
        implicit real*8 (a-h,o-z)
        parameter (np=3,C4=0.01745329D0,ftol=1e-8)
        dimension xo(np),xi(np,np),cart1(3,natom),cart2(3,natom)
        dimension vector1(3,natom),vector2(nvibm,natom*3),xo2(np*2)
        COMMON /COOR/ XAT(1000),YAT(1000),ZAT(1000)
        if (iprod.eq.0) itt=0
        if (iprod.eq.1) itt=1

        write(*,*)'initial geometry'
        call moveframe()

        do ifunc=1,2
        if (ifunc.eq.1) then
                istart=1
                iend=nreact1
        else
                istart=nreact1+1
                iend=natom
        endif

        xo(1)=ang1
        xo(2)=ang2
        xo(3)=ang3
        xo=xo*C4
        if ((iend-istart).ge.1) then
        do i=1,np
        xi(i,i)=1d0
        enddo
        write(*,*) func(xo)
        call powell(xo,xi,np,np,ftol,iter,fret)
        write(*,*) ' iter=',iter,' fret=',fret
        write(*,*) ' final=',(xo(i)/C4,i=1,np)
        write(*,*) ' final geometry='
        write(*,*)'after optimization'
        endif

        cart1=0d0
        do i=istart,iend
        cart1(1,i)=xat((itt+3)*natom+i)
        cart1(2,i)=yat((itt+3)*natom+i)
        cart1(3,i)=zat((itt+3)*natom+i)
        enddo
        call ROTXYZ(natom,cart1,xo(1),xo(2),xo(3))
        do i=istart,iend
        cart2(1,i)=cart1(1,i)+xat(6*natom+ifunc)
        cart2(2,i)=cart1(2,i)+yat(6*natom+ifunc)
        cart2(3,i)=cart1(3,i)+zat(6*natom+ifunc)
        enddo

        do j=1,nvibm
        vector1=0d0
        do i=istart,iend
        vector1(1,i)=eigv(j,(i-1)*3+1,itt+1)
        vector1(2,i)=eigv(j,(i-1)*3+2,itt+1)
        vector1(3,i)=eigv(j,(i-1)*3+3,itt+1)
        enddo
        call ROTXYZ(natom,vector1,xo(1),xo(2),xo(3))
        do i=istart,iend
        vector2(j,(i-1)*3+1)=vector1(1,i)
        vector2(j,(i-1)*3+2)=vector1(2,i)
        vector2(j,(i-1)*3+3)=vector1(3,i)
        enddo
        enddo
 
        enddo

        do j=1,nvibm
        write(*,*)'mode',j,freq(j,itt+1)
        do i=1,natom
c        write(*,'(6f15.8)')xat(itt*natom+i),yat(itt*natom+i)
c     &,zat(itt*natom+i),eigv(j,(i-1)*3+1:(i-1)*3+3,itt+1)
        enddo
        do i=1,natom
        eigv(j,(i-1)*3+1,itt+1)=vector2(j,(i-1)*3+1)
        eigv(j,(i-1)*3+2,itt+1)=vector2(j,(i-1)*3+2)
        eigv(j,(i-1)*3+3,itt+1)=vector2(j,(i-1)*3+3)
       write(*,'(6f15.8)')cart2(1:3,i),eigv(j,(i-1)*3+1:(i-1)*3+3,itt+1)
        enddo
        write(*,*)
        enddo
 
        end subroutine optgeom
 
        function func(xt)
!--> function of three Euler angles (thta,phi,chi)=(xt(1),xt(2),xt(3))
        use projection
        implicit real*8 (a-h,o-z)
        common /coor/ xat(1000),yat(1000),zat(1000)
        dimension xt(3),cartes(3,natom)
        if (iprod.eq.0) itt=0
        if (iprod.eq.1) itt=1
        if (ifunc.eq.1) then
                istart=1
                iend=nreact1
        else
                istart=nreact1+1
                iend=natom
        endif

c!--> rotation in terms of three euler angles
        cartes=0d0
        do i=istart,iend
        cartes(1,i)=xat((itt+3)*natom+i)
        cartes(2,i)=yat((itt+3)*natom+i)
        cartes(3,i)=zat((itt+3)*natom+i)
        enddo
        call ROTXYZ(natom,cartes,xt(1),xt(2),xt(3))

!--> |r-req|^2
        disp=0d0
        do i=istart,iend
        dispi=(xat((itrans+2)*natom+i)-cartes(1,i))**2
     &+(yat((itrans+2)*natom+i)-cartes(2,i))**2
     &+(zat((itrans+2)*natom+i)-cartes(3,i))**2
        disp=disp+dispi
        enddo

        func=dsqrt(disp)

        return
        end function func

!-->....move the coordinates to center of mass frame
        subroutine centmass(igeo,i1,i2)
        use projection
        implicit real*8 (a-h,o-z)
        common /coor/ xat(1000),yat(1000),zat(1000)
        com=0d0
        tmpmass=0d0
        do i=i1,i2
        com(1)=com(1)+xat((igeo-1)*natom+i)*amass(i)
        com(2)=com(2)+yat((igeo-1)*natom+i)*amass(i)
        com(3)=com(3)+zat((igeo-1)*natom+i)*amass(i)
        tmpmass=tmpmass+amass(i)
        enddo
        com=com/tmpmass
        return
        end

        subroutine moveframe()
        use projection
        implicit real*8 (a-h,o-z)
        COMMON /COOR/ XAT(1000),YAT(1000),ZAT(1000)
        if (iprod.eq.0) itt=0
        if (iprod.eq.1) itt=1

!--> COM of the polyatomic molecule
        call centmass(itrans,1,nreact1)
        xat(6*natom+1)=com(1)
        yat(6*natom+1)=com(2)
        zat(6*natom+1)=com(3)
        call centmass(itrans,nreact1+1,natom)
        xat(6*natom+2)=com(1)
        yat(6*natom+2)=com(2)
        zat(6*natom+2)=com(3)
        do i=1,nreact1
        xat((itrans+2)*natom+i)=xat((itrans-1)*natom+i)-xat(6*natom+1)
        yat((itrans+2)*natom+i)=yat((itrans-1)*natom+i)-yat(6*natom+1)
        zat((itrans+2)*natom+i)=zat((itrans-1)*natom+i)-zat(6*natom+1)
        enddo
        do i=nreact1+1,natom
        xat((itrans+2)*natom+i)=xat((itrans-1)*natom+i)-xat(6*natom+2)
        yat((itrans+2)*natom+i)=yat((itrans-1)*natom+i)-yat(6*natom+2)
        zat((itrans+2)*natom+i)=zat((itrans-1)*natom+i)-zat(6*natom+2)
        enddo

!--> COM of the polyatomic molecule
        call centmass(itt+1,1,nreact1)
        xat(6*natom+3)=com(1)
        yat(6*natom+3)=com(2)
        zat(6*natom+3)=com(3)
        call centmass(itt+1,nreact1+1,natom)
        xat(6*natom+4)=com(1)
        yat(6*natom+4)=com(2)
        zat(6*natom+4)=com(3)

        do i=1,nreact1
        xat((itt+3)*natom+i)=xat(itt*natom+i)-xat(6*natom+3)
        yat((itt+3)*natom+i)=yat(itt*natom+i)-yat(6*natom+3)
        zat((itt+3)*natom+i)=zat(itt*natom+i)-zat(6*natom+3)
        enddo
        do i=nreact1+1,natom
        xat((itt+3)*natom+i)=xat(itt*natom+i)-xat(6*natom+4)
        yat((itt+3)*natom+i)=yat(itt*natom+i)-yat(6*natom+4)
        zat((itt+3)*natom+i)=zat(itt*natom+i)-zat(6*natom+4)
        enddo

        end subroutine moveframe


