
        subroutine gasphase()
        use projection
        implicit real*8 (a-h,o-z)
        COMMON /COOR/ XAT(1000),YAT(1000),ZAT(1000)

        write(*,*)
        call Rvector()

        call Rmode()
        write(*,*)

        end subroutine gasphase

        subroutine gassurface()
        use projection
        implicit real*8 (a-h,o-z)
        COMMON /COOR/ XAT(1000),YAT(1000),ZAT(1000)

        write(*,*)
        call xyzmode()

        call rotmode()
        write(*,*)

        end subroutine gassurface


        subroutine printout()
        use projection
        implicit real*8 (a-h,o-z)
        COMMON /COOR/ XAT(1000),YAT(1000),ZAT(1000)

        write(*,*)
        write(*,*)'=============================================='
        if (iprod.eq.0) write(*,*)'svp calculations for reactants'
        if (iprod.eq.1) write(*,*)'svp calculations for products'
        write(*,*)'=============================================='

        write(*,*)
        write(*,*)'print out all svp results'
        write(*,*)

        if (index(reactype,'gas').gt.0) then

        write(*,*)'translational vector by small displacement'

!-->translational modes SVP values and corresponding vectors
        do jj=1,1
        coef=0d0
        do j=1,nmode
        coef=coef+eigv(nmode+jj,j,itrans)*eigv(nimag,j,itrans)
        enddo
        write(*,'(a,f10.3)')' translational',coef
        do i=1,natom
        write(*,'(3f10.3)')eigv(nmode+jj,(i-1)*3+1,itrans)
     &,eigv(nmode+jj,(i-1)*3+2,itrans),eigv(nmode+jj,(i-1)*3+3,itrans)
        enddo
        enddo

        else if (index(reactype,'surface').gt.0) then

        write(*,*)'translational vectors by small displacements'
        write(*,*)'in the sequence of X, Y and Z'

!-->translational modes SVP values and corresponding vectors
        do jj=1,3
        coef=0d0
        do j=1,nmode
        coef=coef+eigv(nmode+jj,j,itrans)*eigv(nimag,j,itrans)
        enddo
        write(*,'(a,f10.3)')' translational modes',coef
        do i=1,natom
        write(*,'(3f10.3)')eigv(nmode+jj,(i-1)*3+1,itrans)
     &,eigv(nmode+jj,(i-1)*3+2,itrans),eigv(nmode+jj,(i-1)*3+3,itrans)
        enddo
        enddo
        write(*,*)

!-->rotational SVP values and corresponding vectors
        do jj=4,6
        coef=0d0
        do j=1,nmode
        coef=coef+eigv(nmode+jj,j,itrans)*eigv(nimag,j,itrans)
        enddo
        write(*,'(a,f10.3)')' rotational modes',coef
        do i=1,natom
        write(*,'(3f10.3)')eigv(nmode+jj,(i-1)*3+1,itrans)
     &,eigv(nmode+jj,(i-1)*3+2,itrans),eigv(nmode+jj,(i-1)*3+3,itrans)
        enddo
        enddo

        endif

        write(*,*)

        do i=1,nvibm
        coef=0d0
        do j=1,nmode
        coef=coef+eigv(i,j,iprod+1)*eigv(nimag,j,itrans)
        enddo
        if (index(software,'gaussian').gt.0) then
           if (i.gt.nvibm-nvibi) then
          write(*,'(a,i,2f10.3)')' reactant vib mode'
     &   ,i,freq(i,iprod+1),coef
           else
          write(*,'(a,i,2f10.3)')' reactant rot or trans
     &mode',i,freq(i,iprod+1),coef
           endif
        else
           if (i.le.nvibi) then
            write(*,'(a,i,2f10.3)')' reactant vib mode'
     &     ,i,freq(i,iprod+1),coef
           else
          write(*,'(a,i,2f10.3)')' reactant rot or trans
     &mode',i,freq(i,iprod+1),coef
           endif
        endif
        enddo

        end subroutine printout

!-->....read parameters from svpinput.txt
        subroutine readfile()
        use projection
        implicit real*8 (a-h,o-z)
        write(*,*)"Sudden vector projection calculations"
        read(5,*)
        read(5,*)
        read(5,*)software
        write(*,*)'software:   ',software
        read(5,*)
        read(5,*)reactype
        write(*,*)'reactype:   ',reactype
        read(5,*)
        read(5,*)iprod
        read(5,*)
        if (iprod.ne.1.and.iprod.ne.0) stop 'iprod error'
        if (index(software,'polyrate').gt.0) then
                read(5,*)fname
                read(5,*)
                read(5,*)
        else if (index(software,'vasp').gt.0) then
                read(5,*)fname
                read(5,*)fname2
                read(5,*)
                if (iprod.eq.1) iprod=0
        else
        if (iprod.eq.1) then
                read(5,*)fname
                read(5,*)fname2
                read(5,*)fname3
        else if (iprod.eq.0) then
                read(5,*)fname
                read(5,*)fname2
                read(5,*)
        endif
        endif
        write(*,*)'iprod',iprod
        read(5,*)
        read(5,*)natom,nreact1
        write(*,*)'natom,nreact1',natom,nreact1
        read(5,*)
        read(5,*)linear1,linear2,linear
        write(*,*)'linear1,linear2,linear',linear1,linear2,linear
        read(5,*)
        read(5,*)(amass(i),i=1,natom)
        read(5,*)
        read(5,*)delt
        read(5,*)
        read(5,*)ang1,ang2,ang3
        write(*,*)"read svpinput.txt done"
        write(*,*)
        end subroutine readfile

!-->....calculate the number of vibrational modes
        subroutine vibnumber()
        use projection
        implicit real*8 (a-h,o-z)

       nreact2=natom-nreact1
       nmode=3*natom

       if (nreact1.le.1) then
               nvibi=0
       else if (nreact1.eq.2) then
               nvibi=1
       else if (linear1.eq.1) then
               nvibi=3*nreact1-5
       else
               nvibi=3*nreact1-6
       endif 
       if (nreact2.le.1) then
            nvibi=nvibi+0
       else if (nreact2.eq.2) then
               nvibi=nvibi+1
       else if (linear2.eq.1) then
               nvibi=nvibi+3*nreact2-5
       else
               nvibi=nvibi+3*nreact2-6
       endif

       if (index(reactype,'surface').gt.0) then
       nvibm=nmode
       else if (index(reactype,'gas').gt.0) then
       nvibm=nmode-6
       if (linear.eq.1) nvibm=nmode-5
       else
               stop 'error in reactype'
       endif
       write(*,*)"vibrational mode for initial states and the entire sys
     &tem"
       write(*,*)nvibi,nvibm
       end subroutine vibnumber

!-->....read geometries and frequencies from files
       subroutine input()
        use projection
        implicit real*8 (a-h,o-z)
        COMMON /COOR/ XAT(1000),YAT(1000),ZAT(1000)
       fname=trim(fname)
       fname2=trim(fname2)
       fname3=trim(fname3)
        if (index(software,'polyrate').gt.0) then
                call inputpolyrate()
                nimag=nvibm
        else if (index(software,'gaussian').gt.0) then
                call inputgaussian()
                nimag=1
        else if (index(software,'vasp').gt.0) then
                call inputvasp()
                nimag=nvibm
        else if (index(software,'molpro').gt.0) then
                call inputmolpro()
                nimag=nvibm
        else
             write(*,*)"your software is not supported now"
             write(*,*)"add a subroutine to read your files by yourself"
             stop
        endif

        tmass=0d0
        tmass1=0d0
        tmass2=0d0
        do i=1,nreact1
        tmass1=tmass1+amass(i)
        enddo
        do i=nreact1+1,natom
        tmass2=tmass2+amass(i)
        enddo
        tmass=tmass1+tmass2

        write(*,*)
        write(*,*)"atomic mass, cartesian coordinates"
        write(*,*)
        do ii=1,itrans
        do i=1,natom
        write(*,'(6f15.8)')amass(i),xat((ii-1)*natom+i)
     &,yat((ii-1)*natom+i),zat((ii-1)*natom+i)
        enddo
        write(*,*)
        enddo

        write(*,*)'frequencies for stationary points'
        write(*,*)
        do i=1,nvibm
        write(*,'(100f15.8)')(freq(i,j),j=1,itrans)
        enddo
        write(*,*)

        if (index(software,'gaussian').gt.0.or.index(software,
     & 'molpro').gt.0) then
        do k=1,itrans
          do i=1,nvibm
            coef=0d0
          do ia=1,natom
            ix1=(ia-1)*3+1
            iy1=(ia-1)*3+2
            iz1=(ia-1)*3+3
            eigv(i,ix1,k)=eigv(i,ix1,k)*dsqrt(amass(ia))
            eigv(i,iy1,k)=eigv(i,iy1,k)*dsqrt(amass(ia))
            eigv(i,iz1,k)=eigv(i,iz1,k)*dsqrt(amass(ia))
            coef=coef+eigv(i,ix1,k)**2+eigv(i,iy1,k)**2+eigv(i,iz1,k)**2
          enddo
            coef=dsqrt(coef)
          do j=1,nmode  
            eigv(i,j,k)=eigv(i,j,k)/coef
          enddo
          enddo
        enddo
        endif

        write(*,*)'imaginary frequency at TS'
        write(*,*)freq(nimag,itrans)
        write(*,*)
        write(*,*)'normal mode vector for reaction mode'
        do i=1,natom
        write(*,'(3f10.3)')eigv(nimag,(i-1)*3+1,itrans)
     &,eigv(nimag,(i-1)*3+2,itrans),eigv(nimag,(i-1)*3+3,itrans)
        enddo
        write(*,*)

        return
       end subroutine input



        subroutine inputvasp()
        use projection
        implicit real*8 (a-h,o-z)
        character f1*130,f2*15,f3*30
        dimension cart(3,1000)
        COMMON /COOR/ XAT(1000),YAT(1000),ZAT(1000)
        open(10,file=fname)
        open(20,file=fname2)
          nn=0
        do ifile=10,20,10
          nn=nn+1
!--> first four lines are lattice parameters, useless for our purpose
        do i=1,4
        read(ifile,*)
        enddo

!--> read total number of atoms
        read(ifile,*)ntatom
        read(ifile,*)

!--> read cartesian coordiantes for all atoms except surface atoms
          do ia=1,ntatom-natom
          read(ifile,*)
          enddo
          do ia=1,natom
          ix=(nn-1)*natom
          read(ifile,*)f2,xat(ix+ia),yat(ix+ia),zat(ix+ia)
          enddo

          read(ifile,*)ntmode
          do i=1,ntmode
          read(ifile,*)freq(i,nn)
          do ia=1,ntatom-natom
          read(ifile,*)
          enddo
          do ia=1,natom
            ix1=(ia-1)*3+1
            iy1=(ia-1)*3+2
            iz1=(ia-1)*3+3
          read(ifile,*)eigv(i,ix1,nn),eigv(i,iy1,nn),eigv(i,iz1,nn)
          enddo
          enddo
          close(ifile)

          enddo

          itrans=nn

         end subroutine inputvasp

        subroutine inputgaussian()
        use projection
        implicit real*8 (a-h,o-z)
        character f1*130,f2*15,f3*30
        COMMON /COOR/ XAT(1000),YAT(1000),ZAT(1000)
        open(10,file=fname)
        open(20,file=fname2)
        nn=0
        if (iprod.eq.1) then
                open(30,file=fname3)
                nfile=30
        else
                nfile=20
        endif
        do ifile=10,nfile,10
        nn=nn+1
100     read(ifile,'(a)',end=101)f1

        if (index(f1,'Thermochemistry').gt.0) then
                read(ifile,*)
                read(ifile,*)
          do ia=1,natom
          read(ifile,*)f3,i1,f3,f3,f3,i2,f3,f3,amass(ia)
          enddo
        endif

        if (index(f1,'Coordinates (Angstroms)').gt.0) then
                read(ifile,*)
                read(ifile,*)
          do ia=(nn-1)*natom+1,natom*nn
          read(ifile,*)ix,i1,i2,xat(ia),yat(ia),zat(ia)
          enddo
        endif

       if (index(f1,'normal coordinates:').gt.0) then
          do im=1,nvibm/3
        read(ifile,*)
        read(ifile,*)
        read(ifile,*)f3,f3,freq(im*3-2,nn),freq(im*3-1,nn),freq(im*3,nn)
        read(ifile,*)
        read(ifile,*)
        read(ifile,*)
        read(ifile,*)
          do ia=1,natom
          ix1=(ia-1)*3+1
          iy1=(ia-1)*3+2
          iz1=(ia-1)*3+3
          read(ifile,*)iax,iay,eigv(im*3-2,ix1,nn),eigv(im*3-2,iy1,nn),
     &eigv(im*3-2,iz1,nn),eigv(im*3-1,ix1,nn),eigv(im*3-1,iy1,nn),
     &eigv(im*3-1,iz1,nn),eigv(im*3,ix1,nn),eigv(im*3,iy1,nn),
     &eigv(im*3,iz1,nn)
          enddo
          enddo
         endif

         goto 100
101     continue
         close(ifile)
         enddo
         itrans=nn
         end subroutine inputgaussian

        subroutine inputmolpro()
        use projection
        implicit real*8 (a-h,o-z)
        character f1*130,f2*15
        COMMON /COOR/ XAT(1000),YAT(1000),ZAT(1000)
        open(10,file=fname)
        open(20,file=fname2)
        nn=0
        if (iprod.eq.1) then
                open(30,file=fname3)
                nfile=30
        else
                nfile=20
        endif
        do ifile=10,nfile,10
        nn=nn+1
100     read(ifile,'(a)',end=101)f1

        if (index(f1,'CALCULATION OF NORMAL MODES').gt.0) then
                do line=1,6
                read(ifile,*)
                enddo
        do i=1,natom
        read(ifile,*)label,f2,charge,xat((nn-1)*natom+i)
     &,yat((nn-1)*natom+i),zat((nn-1)*natom+i)
        enddo
        endif
 
        if (index(f1,'Imaginary Vibration').gt.0) then
                read(ifile,*)
                do i=1,nmode
                read(ifile,*,err=102)imode
                write(*,*)imode,freq(imode,nn)
                enddo
102     continue
                backspace(ifile)
        endif

        if (index(f1,'Vibration        Wavenumber').gt.0) then
                read(ifile,*)
                do i=1,nmode
                read(ifile,*,err=103)jmode
                write(*,*)jmode,freq(imode+jmode,nn)
                enddo
103     continue
                backspace(ifile)
        endif  

        if (index(f1,'Low Vibration').gt.0) then
                read(ifile,*)
                do i=1,nmode
                read(ifile,*,err=104)kmode
                write(*,*)kmode,freq(imode+jmode+kmode,nn)
                enddo
104     continue
                backspace(ifile)
        endif
 
        if (index(f1,'Normal Modes').gt.0.and.index(f1,'low')
     &+index(f1,'imaginary').eq.0) then
                nrow=jmode/5+1
                do i=1,nrow-1
                indx1=(i-1)*5+1
                indx2=i*5
                read(ifile,*)
                read(ifile,*)
                read(ifile,*)f2,f2,(freq(ii,nn),ii=indx1,indx2)
                write(*,*)ii,freq(ii,nn)
                read(ifile,*)
                read(ifile,*)
                do j=1,3*natom
                read(ifile,*)f2,(eigv(ii,j,nn),ii=indx1,indx2)
                enddo
                enddo
                kresd=mod(jmode,5)
                if (kresd.ne.0) then
                indx1=(nrow-1)*5+1
                indx2=(nrow-1)*5+kresd
                read(ifile,*)
                read(ifile,*)
                read(ifile,*)f2,f2,(freq(ii,nn),ii=indx1,indx2)
                read(ifile,*)
                read(ifile,*)
                do j=1,3*natom
                read(ifile,*)f2,(eigv(ii,j,nn),ii=indx1,indx2)
                enddo
                endif
        endif

        if (index(f1,'Normal Modes of imaginary frequencies').gt.0) then
                nrow=imode/5+1
                do i=1,nrow-1
                indx1=jmode+(i-1)*5+1
                indx2=jmode+i*5
                read(ifile,*)
                read(ifile,*)
                read(ifile,*)f2,f2,(freq(ii,nn),ii=indx1,indx2)
                write(*,*)ii,freq(ii,nn)
                do iii=indx1,indx2
                freq(iii,nn)=-freq(iii,nn)
                enddo
                read(ifile,*)
                read(ifile,*)
                do j=1,3*natom
                read(ifile,*)f2,(eigv(ii,j,nn),ii=indx1,indx2)
                enddo
                enddo                                                   
                kresd=mod(imode,5)                                      
                if (kresd.ne.0) then                                    
                indx1=jmode+(nrow-1)*5+1                                
                indx2=jmode+(nrow-1)*5+kresd                            
                read(ifile,*)                                           
                read(ifile,*)                                           
                read(ifile,*)f2,f2,(freq(ii,nn),ii=indx1,indx2)         
                do iii=indx1,indx2
                freq(iii,nn)=-freq(iii,nn)
                enddo
                read(ifile,*)                                          
                read(ifile,*)                                          
                do j=1,3*natom                                          
                read(ifile,*)f2,(eigv(ii,j,nn),ii=indx1,indx2)
                enddo
                endif
        endif

        if (index(f1,'Normal Modes of low/zero frequencies')
     &.gt.0) then
                kmode=nmode-imode-jmode
                nrow=kmode/5+1
                do i=1,nrow-1
                indx1=imode+jmode+(i-1)*5+1
                indx2=imode+jmode+i*5
                read(ifile,*)
                read(ifile,*)
                read(ifile,*)f2,f2,(freq(ii,nn),ii=indx1,indx2)
                do iii=indx1,indx2
                freq(iii,nn)=-freq(iii,nn)
                enddo
                read(ifile,*)
                read(ifile,*)
                do j=1,3*natom
                read(ifile,*)f2,(eigv(ii,j,nn),ii=indx1,indx2)
                enddo
                enddo
                kresd=mod(kmode,5)
                if (kresd.ne.0) then
                indx1=imode+jmode+(nrow-1)*5+1
                indx2=imode+jmode+(nrow-1)*5+kresd
                read(ifile,*)
                read(ifile,*)
                read(ifile,*)f2,f2,(freq(ii,nn),ii=indx1,indx2)
                do iii=indx1,indx2
                freq(iii,nn)=-freq(iii,nn)
                enddo
                read(ifile,*)
                read(ifile,*)
                do j=1,natom*3
                read(ifile,*)f2,(eigv(ii,j,nn),ii=indx1,indx2)
                enddo
                endif

        endif

        goto 100
101     continue
        close(ifile)
        enddo
 
        itrans=nn

         end subroutine inputmolpro

        subroutine inputpolyrate()
        use projection
        implicit real*8 (a-h,o-z)
        character f1*130,f2*15
        COMMON /COOR/ XAT(1000),YAT(1000),ZAT(1000)
        open(10,file=fname)
        nn=0

100     read(10,'(a)',end=101)f1

        if (index(f1,'  Atomic information:').gt.0) then
          read(10,*)
          read(10,*)
          do ia=1,natom
          read(10,*)i1,i2,f2,amass(ia)
          enddo
        endif

                if (index(f1,' Initial guess ').gt.0) then
                        nn=nn+1
          read(10,*)
          read(10,*)
          do ia=(nn-1)*natom+1,natom*nn
          read(10,*)ix,xat(ia),yat(ia),zat(ia)
          enddo
                endif
 
                if (index(f1,' Final geometry ').gt.0) then
          read(10,*)
          read(10,*)
          read(10,*)
          do ia=(nn-1)*natom+1,natom*nn
          read(10,*)ix,xat(ia),yat(ia),zat(ia)
          enddo
                endif

                if (index(f1,' Initial saddle ').gt.0) then
                        nn=nn+1
          read(10,*)
          read(10,*)
          do ia=(nn-1)*natom+1,natom*nn
          read(10,*)xat(ia),yat(ia),zat(ia)
          enddo
                endif
 
       if (index(f1,'Frequencies and normalized eigenvector').gt.0) then
          read(10,*)
          read(10,*)
          do im=1,natom*3/2
          read(10,*)
          read(10,'(15x,f11.2,10x,f20.2)')freq(im*2-1,nn),freq(im*2,nn)
          read(10,*)
          read(10,*)
          do ia=1,natom
          ix1=(ia-1)*3+1
          iy1=(ia-1)*3+2
          iz1=(ia-1)*3+3
          read(10,*)iax,eigv(im*2-1,ix1,nn),eigv(im*2-1,iy1,nn),
     &eigv(im*2-1,iz1,nn),eigv(im*2,ix1,nn),eigv(im*2,iy1,nn),
     &eigv(im*2,iz1,nn)
          enddo
          read(10,*)
          enddo
         endif

         goto 100
101     continue

         itrans=nn

         end subroutine inputpolyrate

