        subroutine Rmode()
        use projection
        implicit real*8 (a-h,o-z)
        COMMON /COOR/ XAT(1000),YAT(1000),ZAT(1000)
        
        if (iprod.eq.0) itt=0
        if (iprod.eq.1) itt=1
        w1=tmass1/tmass
        w2=tmass2/tmass
        delt1=delt*w1
        delt2=delt*w2
        t1=0d0
        t2=0d0

        if (iprod.eq.0) then
        t1(1)=t1(1)+delt2
        t1(2)=t1(2)+delt2
        t1(3)=t1(3)+delt2
        t2(1)=t2(1)+delt1
        t2(2)=t2(2)+delt1
        t2(3)=t2(3)+delt1
        else if (iprod.eq.1) then
        t1(1)=t1(1)-delt2
        t1(2)=t1(2)-delt2
        t1(3)=t1(3)-delt2
        t2(1)=t2(1)-delt1
        t2(2)=t2(2)-delt1
        t2(3)=t2(3)-delt1
        endif 

        do i=1,nreact1
        xat(3*natom+1+i) = t1(1)*vec(1)+xat(itt*natom+i)
        yat(3*natom+1+i) = t1(2)*vec(2)+yat(itt*natom+i)
        zat(3*natom+1+i) = t1(3)*vec(3)+zat(itt*natom+i)
        enddo
        do i=nreact1+1,natom
        xat(3*natom+1+i) = -t2(1)*vec(1)+xat(itt*natom+i)
        yat(3*natom+1+i) = -t2(2)*vec(2)+yat(itt*natom+i)
        zat(3*natom+1+i) = -t2(3)*vec(3)+zat(itt*natom+i)
        enddo

!--> verify that the center of mass does not change

        xat(4*natom+2)=0d0
        yat(4*natom+2)=0d0
        zat(4*natom+2)=0d0
        do i=1,natom
        xat(4*natom+2)=xat(4*natom+2)+amass(i)*xat(3*natom+i+1)
        yat(4*natom+2)=yat(4*natom+2)+amass(i)*yat(3*natom+i+1)
        zat(4*natom+2)=zat(4*natom+2)+amass(i)*zat(3*natom+i+1)
        enddo
        xat(4*natom+2)=xat(4*natom+2)/tmass
        yat(4*natom+2)=yat(4*natom+2)/tmass
        zat(4*natom+2)=zat(4*natom+2)/tmass
        write(*,*)'center of mass check'
        write(*,*)xat(4*natom+2),yat(4*natom+2),zat(4*natom+2)

        do i=1,natom
        eigv(nmode+1,(i-1)*3+1,itrans)=dsqrt(amass(i))*(xat(3*natom+1+i)
     &-xat(itt*natom+i))/delt
        eigv(nmode+1,(i-1)*3+2,itrans)=dsqrt(amass(i))*(yat(3*natom+1+i)
     &-yat(itt*natom+i))/delt
        eigv(nmode+1,(i-1)*3+3,itrans)=dsqrt(amass(i))*(zat(3*natom+1+i)
     &-zat(itt*natom+i))/delt
        enddo

!--> normalize the eigenvector
        sume=0d0
        do i=1,nmode
        sume=sume+eigv(nmode+1,i,itrans)*eigv(nmode+1,i,itrans)
        enddo
        sume=dsqrt(sume)
        do i=1,nmode
        eigv(nmode+1,i,itrans)=eigv(nmode+1,i,itrans)/sume
        enddo

        end subroutine Rmode

        subroutine Rvector()
        use projection
        implicit real*8 (a-h,o-z)
        COMMON /COOR/ XAT(1000),YAT(1000),ZAT(1000)
        if (iprod.eq.0) itt=0
        if (iprod.eq.1) itt=1

!--> COM of the polyatomic molecule
        call centmass(itt+1,1,nreact1)
        xat(3*natom+1)=com(1)
        yat(3*natom+1)=com(2)
        zat(3*natom+1)=com(3)
        call centmass(itt+1,nreact1+1,natom)
        xat(5*natom+1)=com(1)
        yat(5*natom+1)=com(2)
        zat(5*natom+1)=com(3)
!--> define the translational vector
        vec(1)=xat(5*natom+1)-xat(3*natom+1)    !-->x component of vector of R 
        vec(2)=yat(5*natom+1)-yat(3*natom+1)    !-->y component of vector of R 
        vec(3)=zat(5*natom+1)-zat(3*natom+1)    !-->z component of vector of R 

!--> COM of the system
        call centmass(itt+1,1,natom)
        write(*,*)'center of mass'
        write(*,*)com(1:3)
 
        end subroutine Rvector

        subroutine xyzmode()
        use projection
        implicit real*8 (a-h,o-z)
        COMMON /COOR/ XAT(1000),YAT(1000),ZAT(1000)
        if (iprod.eq.0) itt=0
        if (iprod.eq.1) then
        write(*,*)' product is not well defined in gas-surface reaciton'
        stop
        endif

!--> COM of the polyatomic molecule
        xat(3*natom+1)=0d0
        yat(3*natom+1)=0d0
        zat(3*natom+1)=0d0
        do i=1,natom
        xat(3*natom+1)=xat(3*natom+1)+amass(i)*xat(itt*natom+i)
        yat(3*natom+1)=yat(3*natom+1)+amass(i)*yat(itt*natom+i)
        zat(3*natom+1)=zat(3*natom+1)+amass(i)*zat(itt*natom+i)
        enddo
        xat(3*natom+1)=xat(3*natom+1)/tmass1
        yat(3*natom+1)=yat(3*natom+1)/tmass1
        zat(3*natom+1)=zat(3*natom+1)/tmass1
        write(*,*)'center of mass'
        write(*,*)xat(3*natom+1),yat(3*natom+1),zat(3*natom+1)

        do j=1,3
        t1=0d0
        t1(j)=delt
        do i=1,natom
        xat(3*natom+j+i) = t1(1)+xat(itt*natom+i)
        yat(3*natom+j+i) = t1(2)+yat(itt*natom+i)
        zat(3*natom+j+i) = t1(3)+zat(itt*natom+i)
        enddo
 
        do i=1,natom
        eigv(nmode+j,(i-1)*3+1,itrans)=dsqrt(amass(i))*(xat(3*natom+j+i)
     &-xat(itt*natom+i))/delt
        eigv(nmode+j,(i-1)*3+2,itrans)=dsqrt(amass(i))*(yat(3*natom+j+i)
     &-yat(itt*natom+i))/delt
        eigv(nmode+j,(i-1)*3+3,itrans)=dsqrt(amass(i))*(zat(3*natom+j+i)
     &-zat(itt*natom+i))/delt
        enddo

!--> normalize the eigenvector
        sume=0d0
        do i=1,nmode
        sume=sume+eigv(nmode+j,i,itrans)*eigv(nmode+j,i,itrans)
        enddo
        sume=dsqrt(sume)
        do i=1,nmode
        eigv(nmode+j,i,itrans)=eigv(nmode+j,i,itrans)/sume
        enddo
        enddo

        end subroutine xyzmode

        subroutine rotmode()
        use projection
        implicit real*8 (a-h,o-z)
        real*8 carts(3,natom),ang(3)
        COMMON /COOR/ XAT(1000),YAT(1000),ZAT(1000)
        if (iprod.eq.0) itt=0
        if (iprod.eq.1) then
        write(*,*)' product is not well defined in gas-surface reaciton'
        stop
        endif

!--> COM of the polyatomic molecule
        xat(3*natom+1)=0d0
        yat(3*natom+1)=0d0
        zat(3*natom+1)=0d0
        do i=1,natom
        xat(3*natom+1)=xat(3*natom+1)+amass(i)*xat(itt*natom+i)
        yat(3*natom+1)=yat(3*natom+1)+amass(i)*yat(itt*natom+i)
        zat(3*natom+1)=zat(3*natom+1)+amass(i)*zat(itt*natom+i)
        enddo
        xat(3*natom+1)=xat(3*natom+1)/tmass1
        yat(3*natom+1)=yat(3*natom+1)/tmass1
        zat(3*natom+1)=zat(3*natom+1)/tmass1
        write(*,*)'center of mass' 
        write(*,*)xat(3*natom+1),yat(3*natom+1),zat(3*natom+1)

!--> rotation along the X,Y,Z axis
        do j=1,3
        ang=0d0
        ang(j)=delt
        do i=1,natom
        carts(1,i)=xat(itt*natom+i)-xat(3*natom+1) 
        carts(2,i)=yat(itt*natom+i)-yat(3*natom+1) 
        carts(3,i)=zat(itt*natom+i)-zat(3*natom+1) 
        enddo
        call ROTXYZ(natom,carts,ang(1),ang(2),ang(3))
        do i=1,natom
        xat(3*natom+1+i) = xat(3*natom+1)+carts(1,i)
        yat(3*natom+1+i) = yat(3*natom+1)+carts(2,i)
        zat(3*natom+1+i) = zat(3*natom+1)+carts(3,i)
        enddo

        do i=1,natom
      eigv(nmode+3+j,(i-1)*3+1,itrans)=dsqrt(amass(i))*(xat(3*natom+1+i)
     &-xat(itt*natom+i))/1.0d0
      eigv(nmode+3+j,(i-1)*3+2,itrans)=dsqrt(amass(i))*(yat(3*natom+1+i)
     &-yat(itt*natom+i))/1.0d0
      eigv(nmode+3+j,(i-1)*3+3,itrans)=dsqrt(amass(i))*(zat(3*natom+1+i)
     &-zat(itt*natom+i))/1.0d0
        enddo

!--> normalize the eigenvector
        sume=0d0
        do i=1,nmode
        sume=sume+eigv(nmode+3+j,i,itrans)*eigv(nmode+3+j,i,itrans)
        enddo
        sume=dsqrt(sume)
        do i=1,nmode
        eigv(nmode+3+j,i,itrans)=eigv(nmode+3+j,i,itrans)/sume
        enddo
        enddo

        end subroutine rotmode

        subroutine cartobond(cart,bond)
!-->tranfrom cartesian coordinates to six interbonds
!-->cart(3,1-4)=cartesian coordinates(1,2,3=x,y,z) of four atoms A,B,C,D.
!-->bond(1-6)=AB,AC,AD,BC,BD,CD bond distance.
        implicit real*8(a-h,o-z)
        dimension cart(3,4),bond(6)
        bond(1)=dsqrt((cart(1,1)-cart(1,2))**2+(cart(2,1)-cart(2,2))**2+
     &(cart(3,1)-cart(3,2))**2)
        bond(2)=dsqrt((cart(1,1)-cart(1,3))**2+(cart(2,1)-cart(2,3))**2+
     &(cart(3,1)-cart(3,3))**2)
        bond(3)=dsqrt((cart(1,1)-cart(1,4))**2+(cart(2,1)-cart(2,4))**2+
     &(cart(3,1)-cart(3,4))**2)
        bond(4)=dsqrt((cart(1,3)-cart(1,2))**2+(cart(2,3)-cart(2,2))**2+
     &(cart(3,3)-cart(3,2))**2)
        bond(5)=dsqrt((cart(1,4)-cart(1,2))**2+(cart(2,4)-cart(2,2))**2+
     &(cart(3,4)-cart(3,2))**2)
        bond(6)=dsqrt((cart(1,3)-cart(1,4))**2+(cart(2,3)-cart(2,4))**2+
     &(cart(3,3)-cart(3,4))**2)
        end

!  ***************************************************************************
!  *
!  *
!  *   Program    :  rotxyz
!  *
!  *   Function   :  rotate a vector as the order of x, y and then z axis
!  *
!  *
!  *
!  ***************************************************************************
       subroutine ROTXYZ(natom,cartes,a,b,c)
       implicit none
       integer :: natom,iatom,ixyz,jxyz
       real*8  :: a,b,c,tmatrot(3,3),cartes(3,natom),
     &            sina,cosa,sinb,cosb,sinc,cosc,temp(3)
c
       sina=dsin(a); cosa=dcos(a)
       sinb=dsin(b); cosb=dcos(b)
       sinc=dsin(c); cosc=dcos(c)
c
       tmatrot(1,1)= cosb*cosc
       tmatrot(2,1)= cosb*sinc
       tmatrot(3,1)=-sinb

       tmatrot(1,2)= cosc*sina*sinb-cosa*sinc
       tmatrot(2,2)= cosa*cosc+sina*sinb*sinc
       tmatrot(3,2)= sina*cosb

       tmatrot(1,3)= cosa*sinb*cosc+sina*sinc
       tmatrot(2,3)= -cosc*sina+cosa*sinb*sinc
       tmatrot(3,3)= cosa*cosb
c
       do 3000 iatom=1,natom
          do 2000 ixyz=1,3
             temp(ixyz)=0.0d0
             do 1800 jxyz=1,3
                temp(ixyz)=temp(ixyz)
     &                    +tmatrot(ixyz,jxyz)*cartes(jxyz,iatom)
 1800        continue
 2000     continue
          do 2200 ixyz=1,3
             cartes(ixyz,iatom)=temp(ixyz)
 2200     continue
 3000  continue
       return
       end


       subroutine fractocart(xf,yf,zf,xc,yc,zc)
!-->-->-->Convert fractional coordinates to cartesian coordinates
!-->-->-->Reference:  http://en.wikipedia.org/wiki/Fractional_coordinates#cite_note-0
        implicit real*8 (a-h,o-z)
        common /para/ alpha,beta,gama,a,b,c     !-->-->angles in radian, lattice parameters in angstrom
        v=dsqrt(1d0-dcos(alpha)**2-dcos(beta)**2-dcos(gama)**2+2d0*
     &dcos(alpha)*dcos(beta)*dcos(gama))
       xc=xf*a+b*dcos(gama)*yf+c*dcos(beta)*zf
       yc=b*dsin(gama)*yf+c*(dcos(alpha)-dcos(beta)*dcos(gama))*zf
     &/dsin(gama)                                                     
       zc=zf*c*v/dsin(gama)                    
        end 

        subroutine cartofrac(xc,yc,zc,xf,yf,zf)
!-->-->-->Convert fractional coordinates to cartesian coordinates
!-->-->-->Reference:  http://en.wikipedia.org/wiki/Fractional_coordinates#cite_note-0
        implicit real*8 (a-h,o-z)
        common /para/ alpha,beta,gama,a,b,c     !-->-->angles in radian, lattice parameters in angstrom
        v=dsqrt(1d0-dcos(alpha)**2-dcos(beta)**2-dcos(gama)**2+2d0*
     &dcos(alpha)*dcos(beta)*dcos(gama))
        xf=xc/a-dcos(gama)*yc/a/dsin(gama)+(dcos(alpha)*dcos(gama)
     &-dcos(beta))*zc/a/v/dsin(gama)
        yf=yc/b/dsin(gama)+(dcos(beta)*dcos(gama)-dcos(alpha))*zc
     &/b/v/dsin(gama)
        zf=zc*dsin(gama)/c/v
        end


c *******************************
      real function bndlen(i1,i2)

c ..................................................
c  PURPOSE: return bond length between atoms i1 & i2
c
c  INPUT:   i1,i2 - indices of 2 atoms
c
c ..................................................
      implicit real*8 (a-h,o-z)

      COMMON /COOR/ XAT(1000),YAT(1000),ZAT(1000)

      bndlen=sqrt( (xat(i1)-xat(i2))**2
     #            +(yat(i1)-yat(i2))**2+(zat(i1)-zat(i2))**2 )

      return
      end
c **********************************
      real function valang(i1,i2,i3)

c .........................................
c  PURPOSE: return valence angle (i1,i2,i3)
c           [in rad.] with 'i2' as vertex
c
c  INPUT:   i1,i2,i3 - indices of 3 atoms
c .........................................

      implicit real*8 (a-h,o-z)
      COMMON /COOR/ XAT(1000),YAT(1000),ZAT(1000)

      h1=xat(i2)
      h2=yat(i2)
      h3=zat(i2)
      x1=xat(i1)-h1
      x2=yat(i1)-h2
      x3=zat(i1)-h3
      y1=xat(i3)-h1
      y2=yat(i3)-h2
      y3=zat(i3)-h3

      x=x1*x1+x2*x2+x3*x3
      y=y1*y1+y2*y2+y3*y3
      u=x*y

      if (u.ne.0d0) then

        a=(x1*y1+x2*y2+x3*y3)/dsqrt(u)
        a=max(a,-1d0)
        a=min(a,1d0)
        valang=dacos(a)
        return

      else
        write (*,'(a,3i5)')' valang> Error in coordinates of atoms #: '
     #                     ,i1,i2,i3
        stop
      endif

      end
c *************************************
      real function dihedr(i1,i2,i3,i4)

c .............................................
c  PURPOSE: return dihedral angle (i1,i2,i3,i4)
c           [in rad.]
c
c  INPUT:   i1,i2,i3,i4 - indices of four atoms
c
c  CALLS:   none
c .............................................

      implicit real*8 (a-h,o-z)
      COMMON /COOR/ XAT(1000),YAT(1000),ZAT(1000)

      x1=xat(i2)-xat(i1)
      y1=yat(i2)-yat(i1)
      z1=zat(i2)-zat(i1)
      x2=xat(i3)-xat(i2)
      y2=yat(i3)-yat(i2)
      z2=zat(i3)-zat(i2)
      ux1=y1*z2-z1*y2
      uy1=z1*x2-x1*z2
      uz1=x1*y2-y1*x2
      x1=xat(i4)-xat(i3)
      y1=yat(i4)-yat(i3)
      z1=zat(i4)-zat(i3)
      ux2=z1*y2-y1*z2
      uy2=x1*z2-z1*x2
      uz2=y1*x2-x1*y2

      u1=ux1*ux1+uy1*uy1+uz1*uz1
      u2=ux2*ux2+uy2*uy2+uz2*uz2
      u=u1*u2

      if (u.ne.0d0) then
        a=(ux1*ux2+uy1*uy2+uz1*uz2)/sqrt(u)
        a=max(a,-1d0)
        a=min(a,1d0)
        dihedr=acos(a)
        if (ux1*(uy2*z2-uz2*y2)+uy1*(uz2*x2-ux2*z2)+
     #      uz1*(ux2*y2-uy2*x2).lt.0.0) dihedr =-dihedr
        return
      else
        write (*,'(a,4i5)')' dihedr> Error in coordinates of atoms #: '
     #                     ,i1,i2,i3,i4
        stop
      endif

      end

